#include <iostream>
using namespace std;
int arr[100000];
int main()
{



    int n,br=0,j=0,br2=0;
    char iz;
    cin>>n;
    string str;
    for(int i=0; i<n; i++)
    {
        cin>>arr[i];
        if(i>1)
        {
            if(arr[i-1]>arr[i]&&arr[i-1]>arr[i-2]||arr[i-1]<arr[i]&&arr[i-1]<arr[i-2])
            {
                iz=i;
                str=str+iz+" ";
                br+=2;
            }
        }
    }
    for(int i=0; i<n; i++)
    {
        while(str[j]<i)
        {
            j+=2;
        }
        br2+=str[j]-i+1;
        
        j-=2;

    }
    cout<<br2-1;
    return 0;
}
